package org.antlr.misc;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.LinkedHashSet;
import java.util.List;

public class OrderedHashSet<T> extends LinkedHashSet<T> {
  protected List<T> elements = new ArrayList<T>();
  
  public T get(int i) {
    return this.elements.get(i);
  }
  
  public T set(int i, T value) {
    T oldElement = this.elements.get(i);
    this.elements.set(i, value);
    super.remove(oldElement);
    super.add(value);
    return oldElement;
  }
  
  public boolean add(T value) {
    boolean result = super.add(value);
    if (result)
      this.elements.add(value); 
    return result;
  }
  
  public boolean remove(Object o) {
    throw new UnsupportedOperationException();
  }
  
  public void clear() {
    this.elements.clear();
    super.clear();
  }
  
  public List<T> elements() {
    return this.elements;
  }
  
  public Iterator<T> iterator() {
    return this.elements.iterator();
  }
  
  public Object[] toArray() {
    return this.elements.toArray();
  }
  
  public int size() {
    return this.elements.size();
  }
  
  public String toString() {
    return this.elements.toString();
  }
}
